from cStringIO import StringIO
import string

from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews

from Products.SQLExporter import config
from Products.SQLExporter.SQLExporterTool import SQLExporterTool

def install(self):
    outStream = StringIO()

    skinsTool = getToolByName(self, 'portal_skins')
    addDirectoryViews(skinsTool, 'skins', config.GLOBALS)
    installSubSkin(self, config.SKIN_NAME, outStream)
    addTool(self)
    installConfiglet(self, outStream)
    return outStream.getvalue()

def uninstall(self) :
    outStream = StringIO()
    uninstallConfiglet(self, outStream)
    return outStream.getvalue()

def addTool(self):
    if not hasattr(self, SQLExporterTool.id):
        addTool = self.manage_addProduct['SQLExporter'].manage_addTool
        addTool(SQLExporterTool.meta_type)

def installSubSkin(context, skinFolder, outStream):
    """
        Install a subskin in portal_skins
    """
    skinsTool = getToolByName(context, 'portal_skins')
    for skin in skinsTool.getSkinSelections() :
        path = skinsTool.getSkinPath(skin)
        path = map(string.strip, string.split(path, ','))
        if not skinFolder in path:
            try:
                path.insert(path.index('custom') + 1, skinFolder)
            except ValueError:
                path.append(skinFolder)
            path = string.join(path, ', ')
            skinsTool.addSkinSelection(skin, path)
            outStream.write('Subskin successfully installed into %s.\n' % skin)
        else:
            outStream.write('*** Subskin was already installed into %s.\n' % skin)

def installConfiglet(self, out) :
    configTool = getToolByName(self, 'portal_controlpanel', None)
    if configTool:
        for conf in config.configlets:
            configTool.registerConfiglet(**conf)
            out.write('Added configlet %s\n' % conf['id'])

def uninstallConfiglet(self, out) :
    configTool = getToolByName(self, 'portal_controlpanel', None)
    if configTool:
        for conf in config.configlets:
            configTool.unregisterConfiglet(conf['id'])
            out.write('Removed configlet %s\n' % conf['id'])
